import type { Ref, PropType } from 'vue';
export type NetworkType = null | 'Unknown' | '2g' | '3g' | '4g' | 'wifi';
export type Evented = {
    currentTarget: {
        effectiveType: NetworkType;
        downlink: number;
    };
};
declare global {
    interface Navigator {
        connection: {
            onchange: null | Function;
            addEventListener(type: 'change', listener: (e: Evented) => void): void;
            removeEventListener(type: 'change', listener: (e: Evented) => void): void;
            effectiveType: NetworkType;
            rtt: number;
            downlink: number;
            saveData: boolean;
        };
    }
}
declare const _default: import("vue").DefineComponent<{
    unknownClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
    slowClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
    fastClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
}, {
    type: Ref<NetworkType>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, import("vue").EmitsOptions, "network-type" | "network-speed", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    unknownClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
    slowClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
    fastClass: {
        type: PropType<string | null>;
        required: false;
        default: null;
    };
}>>, {
    unknownClass: string | null;
    slowClass: string | null;
    fastClass: string | null;
}>;
export default _default;
